# USB Types

## USB Type A

Connector type 0. The standard USB 2.0 ports we all are accustomed to.

![Type A](https://upload.wikimedia.org/wikipedia/commons/7/7e/USB_Type-A_receptacle.svg)

## USB Type Mini-AB

Connector type 1. Probably one of the most obscure USB port types. Designed to mate with both USB Mini-A and USB Mini-B.

![Mini-AB](https://upload.wikimedia.org/wikipedia/commons/f/f3/USB_Mini-AB_receptacle.svg)

## ExpressCard

Connector type 2. A connector type almost never used, this is for the USB side of ExpressCards.

## USB 3 Type A

Connector type 3. The standard USB 3.0 ports we are all accustomed to.

![USB 3 Type A](https://upload.wikimedia.org/wikipedia/commons/f/f4/USB_3.0_Type-A_receptacle_blue.svg)

## USB 3 Type B

Connector type 4. Commonly seen on hard drives, but not really on computers.

![USB 3 Type B](https://upload.wikimedia.org/wikipedia/commons/8/8c/USB_3.0_Type-B_receptacle_blue.svg)

## USB 3 Type Micro-B

Connector type 5. Commonly seen on smaller hard drives and some old Galaxy phones, but again, not really on computers.

![USB 3 Type Micro-B](https://upload.wikimedia.org/wikipedia/commons/a/a8/USB_3.0_Micro-B_receptacle.svg)

## USB 3 Type Micro-AB

Connector type 6. Another one of those obscure port types. Designed to mate with both USB Micro-A and USB Micro-B.

![USB 3 Type Micro-AB](https://upload.wikimedia.org/wikipedia/commons/6/6c/USB_Micro-AB_receptacle.svg)

## USB 3 Type Power-B

Connector type 7. Yet another obscure port type. The USB 3 Type B connector with extra pins for power.

![USB 3 Type Power-B](https://upload.wikimedia.org/wikipedia/commons/9/9c/USB_3.0_Type-B_Powered.gif)

## USB Type C

There are 3 connector types for USB Type C connectors: Type C - USB 2 only, Type C - with switch, and Type C - without switch. All look like this:

![USB Type C](https://upload.wikimedia.org/wikipedia/commons/9/98/USB_Type-C_icon.svg)

* USB Type C - USB 2 only is connector type 8. Only USB 2 is wired to the USB C port.
* USB Type C - with switch is connector type 9. Both USB 2 and USB 3 are wired to the USB C port, and a switch in the circuitry allows for use of the same two personalities when the connector is flipped.
* USB Type C - without switch is connector type 10. Both USB 2 and USB 3 are wired to the USB C port like when with a switch, but when flipping the connector, different personalities are used.

## Internal

Connector type 255. Used for any internal devices, like card readers, fingerprint scanners, webcams, etc.

## Picture Credits

Pictures sourced from [Wikipedia](https://en.wikipedia.org/wiki/USB_hardware). All credit goes to the authors.
